unit RichLabel;

interface

uses
  SysUtils, Classes, Controls, StdCtrls, ComCtrls, designeditors, DesignIntf;

type
  TRichText = type string;

  TRichLabel = class(TRichEdit)
  private
    function GetRichText: TRichText;
    procedure SetRichText(const Value: TRichText);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner:TComponent); override;  
  published
    { Published declarations }
    property RichText:TRichText read GetRichText write SetRichText;
  end;

  TRichTextProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

procedure Register;

implementation

uses Forms, RichEditorImpl;

procedure Register;
begin
  RegisterComponents('Ciuly''s UI Components', [TRichLabel]);
  RegisterPropertyEditor(TypeInfo(TRichText), nil, '', TRichTextProperty);
end;

{ TRichLabel }

constructor TRichLabel.Create(AOwner: TComponent);
begin
  inherited;
  BorderStyle:=bsnone;
  ReadOnly:=true;
  PlainText:=false;
  Height:=17;
//  Width:= calculate according to textwidth
end;

function TRichLabel.GetRichText: TRichText;
var ss:TStringStream;
begin
  ss:=TStringStream.Create('');
  lines.SaveToStream(ss);
  result:=ss.DataString;
  ss.free;
end;

procedure TRichLabel.SetRichText(const Value: TRichText);
var ss:TStringStream;
begin
  ss:=TStringStream.Create('');
  ss.WriteString(Value);
  ss.Seek(0, soFromBeginning);
  lines.LoadFromStream(ss);
  ss.free;
end;

{ TRichTextProperty }

procedure TRichTextProperty.Edit;
begin
  with TRichEditor.Create(Application) do
  begin
    Text:=getvalue;
    if execute then
      SetValue(Text);
    free;
  end;
end;

function TRichTextProperty.GetAttributes: TPropertyAttributes;
begin
  result:=[paDialog, paFullWidthName];
end;

end.
